#include "myserver.h"

MyServer::MyServer(int nPort, QObject *parent) :
    QObject(parent){
    qDebug() << nPort;

    server = new QTcpServer(this);
    if(!server->listen(QHostAddress::Any, nPort)){
        qDebug() << "Unable to start the server" << server->errorString();
        server->close();
        return;
    } else qDebug() << "Listenen on";

    QObject::connect(server, SIGNAL(newConnection()), this, SLOT(slotNewConnection()));
}

/*virtual*/
void MyServer::slotNewConnection(){
    QTcpSocket *clientSocket = server->nextPendingConnection();

    QObject::connect(clientSocket, SIGNAL(disconnected()), clientSocket, SLOT(deleteLater()));
    QObject::connect(clientSocket, SIGNAL(readyRead()), this, SLOT(slotReadClient()));

    //log->append(clientSocket->);
    QVariant var(clientSocket->peerPort());
    sendToClient(clientSocket, "Server Response: Connected! Your port is " + var.toString());
}

void MyServer::slotReadClient(){
    QTcpSocket *clientSocket = (QTcpSocket*)sender();
    //QDataStream in(clientSocket);
    //in.setVersion(QDataStream::Qt_4_7);
    QVariant var(clientSocket->peerPort());
    QTextStream in(clientSocket);

    /*for(;;){
        if(!blockSize){
            if(clientSocket->bytesAvailable() < sizeof(quint16)){
                break;
            }
            in >> blockSize;
            qDebug() << "Block Size is: " << blockSize;
        }

        if(clientSocket->bytesAvailable() < blockSize){
            break;
        }*/

        //QTime time;
        QString str;
        in >> str;

        QString strMessage = var.toString() + " has sent - " + str;

        blockSize = 0;
        this->sendToClient(clientSocket, "Server Response: reseived \"" + str + "\"");
    //}
    /*
    QString Str;
    Str = in.readLine();
    log->append(Str);*/
}

void MyServer::sendToClient(QTcpSocket *pSocket, const QString &str){
    QByteArray arrBlock;
    QDataStream out(&arrBlock, QIODevice::WriteOnly);
    out.setVersion(QDataStream::Qt_4_7);
    out << quint16(0) << QTime::currentTime() << str;

    out.device()->seek(0);
    out << quint16(arrBlock.size() - sizeof(quint16));

    pSocket->write(arrBlock);
}

